#include "LevenshteinBitParalelismTest.h"

#include <string/LinearString.h>
#include <stringology/simulations/LevenshteinBitParalelism.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( LevenshteinBitParalelismTest, "bit paralelism" );
CPPUNIT_TEST_SUITE_REGISTRATION ( LevenshteinBitParalelismTest );

void LevenshteinBitParalelismTest::testSimple() {
  auto text = string::LinearString<>("adcabcaabadbbca");
  auto pattern = string::LinearString<>("adbbca");

  ext::vector<unsigned int> expected_result = {0, 1, 2, 4, 6, 7, 8, 9};
  auto result = stringology::simulations::LevenshteinBitParalelism::search(text, pattern, 3);
  CPPUNIT_ASSERT(expected_result == result);
}

void LevenshteinBitParalelismTest::setUp() { }

void LevenshteinBitParalelismTest::tearDown() { }
